# coding: utf-8

"""
    VMware Aria Automation Assembler / Service Broker API

    A multi-cloud API for Cloud Automation Services  The APIs that list collections of resources also support OData like implementation. Below query params can be used across Assembler / Service Broker entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/catalog/api/items?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/catalog/api/items?$top=10&$skip=2```  3. `page` and `size` - page used in conjunction with `$size` helps in pagination of resources.      ```/catalog/api/items?page=0&size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /catalog/api/items?$filter=startswith(name, 'Act')     /catalog/api/items?$filter=toupper(name) eq 'ACTIVATE'     /catalog/api/items?$filter=substringof('renameVM', name)     /catalog/api/items?$filter=name eq 'ABCD'  # noqa: E501

    OpenAPI spec version: 2020-08-25
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ApiPoliciesBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'description': 'str',
        'type_id': 'str',
        'enforcement_type': 'str',
        'org_id': 'str',
        'project_id': 'str',
        'scope_criteria': 'PolicyapipoliciesScopeCriteria',
        'definition': 'object',
        'definition_legend': 'dict(str, PolicyapipoliciesDefinitionLegend)',
        'criteria': 'PolicyapipoliciesScopeCriteria',
        'created_at': 'datetime',
        'created_by': 'str',
        'last_updated_at': 'datetime',
        'last_updated_by': 'str',
        'statistics': 'PolicyapipoliciesStatistics'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'description': 'description',
        'type_id': 'typeId',
        'enforcement_type': 'enforcementType',
        'org_id': 'orgId',
        'project_id': 'projectId',
        'scope_criteria': 'scopeCriteria',
        'definition': 'definition',
        'definition_legend': 'definitionLegend',
        'criteria': 'criteria',
        'created_at': 'createdAt',
        'created_by': 'createdBy',
        'last_updated_at': 'lastUpdatedAt',
        'last_updated_by': 'lastUpdatedBy',
        'statistics': 'statistics'
    }

    def __init__(self, id=None, name=None, description=None, type_id=None, enforcement_type=None, org_id=None, project_id=None, scope_criteria=None, definition=None, definition_legend=None, criteria=None, created_at=None, created_by=None, last_updated_at=None, last_updated_by=None, statistics=None):  # noqa: E501
        """ApiPoliciesBody - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._description = None
        self._type_id = None
        self._enforcement_type = None
        self._org_id = None
        self._project_id = None
        self._scope_criteria = None
        self._definition = None
        self._definition_legend = None
        self._criteria = None
        self._created_at = None
        self._created_by = None
        self._last_updated_at = None
        self._last_updated_by = None
        self._statistics = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        self.type_id = type_id
        if enforcement_type is not None:
            self.enforcement_type = enforcement_type
        if org_id is not None:
            self.org_id = org_id
        if project_id is not None:
            self.project_id = project_id
        if scope_criteria is not None:
            self.scope_criteria = scope_criteria
        if definition is not None:
            self.definition = definition
        if definition_legend is not None:
            self.definition_legend = definition_legend
        if criteria is not None:
            self.criteria = criteria
        if created_at is not None:
            self.created_at = created_at
        if created_by is not None:
            self.created_by = created_by
        if last_updated_at is not None:
            self.last_updated_at = last_updated_at
        if last_updated_by is not None:
            self.last_updated_by = last_updated_by
        if statistics is not None:
            self.statistics = statistics

    @property
    def id(self):
        """Gets the id of this ApiPoliciesBody.  # noqa: E501

        The policy ID.  # noqa: E501

        :return: The id of this ApiPoliciesBody.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ApiPoliciesBody.

        The policy ID.  # noqa: E501

        :param id: The id of this ApiPoliciesBody.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this ApiPoliciesBody.  # noqa: E501

        The policy name.  # noqa: E501

        :return: The name of this ApiPoliciesBody.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ApiPoliciesBody.

        The policy name.  # noqa: E501

        :param name: The name of this ApiPoliciesBody.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this ApiPoliciesBody.  # noqa: E501

        The policy description.  # noqa: E501

        :return: The description of this ApiPoliciesBody.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ApiPoliciesBody.

        The policy description.  # noqa: E501

        :param description: The description of this ApiPoliciesBody.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def type_id(self):
        """Gets the type_id of this ApiPoliciesBody.  # noqa: E501

        The policy type ID.  # noqa: E501

        :return: The type_id of this ApiPoliciesBody.  # noqa: E501
        :rtype: str
        """
        return self._type_id

    @type_id.setter
    def type_id(self, type_id):
        """Sets the type_id of this ApiPoliciesBody.

        The policy type ID.  # noqa: E501

        :param type_id: The type_id of this ApiPoliciesBody.  # noqa: E501
        :type: str
        """
        if type_id is None:
            raise ValueError("Invalid value for `type_id`, must not be `None`")  # noqa: E501

        self._type_id = type_id

    @property
    def enforcement_type(self):
        """Gets the enforcement_type of this ApiPoliciesBody.  # noqa: E501

        Defines enforcement type for policy. Default enforcement type is HARD.  # noqa: E501

        :return: The enforcement_type of this ApiPoliciesBody.  # noqa: E501
        :rtype: str
        """
        return self._enforcement_type

    @enforcement_type.setter
    def enforcement_type(self, enforcement_type):
        """Sets the enforcement_type of this ApiPoliciesBody.

        Defines enforcement type for policy. Default enforcement type is HARD.  # noqa: E501

        :param enforcement_type: The enforcement_type of this ApiPoliciesBody.  # noqa: E501
        :type: str
        """
        allowed_values = ["SOFT", "HARD"]  # noqa: E501
        if enforcement_type not in allowed_values:
            raise ValueError(
                "Invalid value for `enforcement_type` ({0}), must be one of {1}"  # noqa: E501
                .format(enforcement_type, allowed_values)
            )

        self._enforcement_type = enforcement_type

    @property
    def org_id(self):
        """Gets the org_id of this ApiPoliciesBody.  # noqa: E501

        The ID of the organization to which the policy belongs.  # noqa: E501

        :return: The org_id of this ApiPoliciesBody.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this ApiPoliciesBody.

        The ID of the organization to which the policy belongs.  # noqa: E501

        :param org_id: The org_id of this ApiPoliciesBody.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def project_id(self):
        """Gets the project_id of this ApiPoliciesBody.  # noqa: E501

        For project-scoped policies, the ID of the project to which the policy belongs.  # noqa: E501

        :return: The project_id of this ApiPoliciesBody.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this ApiPoliciesBody.

        For project-scoped policies, the ID of the project to which the policy belongs.  # noqa: E501

        :param project_id: The project_id of this ApiPoliciesBody.  # noqa: E501
        :type: str
        """

        self._project_id = project_id

    @property
    def scope_criteria(self):
        """Gets the scope_criteria of this ApiPoliciesBody.  # noqa: E501


        :return: The scope_criteria of this ApiPoliciesBody.  # noqa: E501
        :rtype: PolicyapipoliciesScopeCriteria
        """
        return self._scope_criteria

    @scope_criteria.setter
    def scope_criteria(self, scope_criteria):
        """Sets the scope_criteria of this ApiPoliciesBody.


        :param scope_criteria: The scope_criteria of this ApiPoliciesBody.  # noqa: E501
        :type: PolicyapipoliciesScopeCriteria
        """

        self._scope_criteria = scope_criteria

    @property
    def definition(self):
        """Gets the definition of this ApiPoliciesBody.  # noqa: E501


        :return: The definition of this ApiPoliciesBody.  # noqa: E501
        :rtype: object
        """
        return self._definition

    @definition.setter
    def definition(self, definition):
        """Sets the definition of this ApiPoliciesBody.


        :param definition: The definition of this ApiPoliciesBody.  # noqa: E501
        :type: object
        """

        self._definition = definition

    @property
    def definition_legend(self):
        """Gets the definition_legend of this ApiPoliciesBody.  # noqa: E501


        :return: The definition_legend of this ApiPoliciesBody.  # noqa: E501
        :rtype: dict(str, PolicyapipoliciesDefinitionLegend)
        """
        return self._definition_legend

    @definition_legend.setter
    def definition_legend(self, definition_legend):
        """Sets the definition_legend of this ApiPoliciesBody.


        :param definition_legend: The definition_legend of this ApiPoliciesBody.  # noqa: E501
        :type: dict(str, PolicyapipoliciesDefinitionLegend)
        """

        self._definition_legend = definition_legend

    @property
    def criteria(self):
        """Gets the criteria of this ApiPoliciesBody.  # noqa: E501


        :return: The criteria of this ApiPoliciesBody.  # noqa: E501
        :rtype: PolicyapipoliciesScopeCriteria
        """
        return self._criteria

    @criteria.setter
    def criteria(self, criteria):
        """Sets the criteria of this ApiPoliciesBody.


        :param criteria: The criteria of this ApiPoliciesBody.  # noqa: E501
        :type: PolicyapipoliciesScopeCriteria
        """

        self._criteria = criteria

    @property
    def created_at(self):
        """Gets the created_at of this ApiPoliciesBody.  # noqa: E501

        Policy creation timestamp.  # noqa: E501

        :return: The created_at of this ApiPoliciesBody.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this ApiPoliciesBody.

        Policy creation timestamp.  # noqa: E501

        :param created_at: The created_at of this ApiPoliciesBody.  # noqa: E501
        :type: datetime
        """

        self._created_at = created_at

    @property
    def created_by(self):
        """Gets the created_by of this ApiPoliciesBody.  # noqa: E501

        Policy author.  # noqa: E501

        :return: The created_by of this ApiPoliciesBody.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this ApiPoliciesBody.

        Policy author.  # noqa: E501

        :param created_by: The created_by of this ApiPoliciesBody.  # noqa: E501
        :type: str
        """

        self._created_by = created_by

    @property
    def last_updated_at(self):
        """Gets the last_updated_at of this ApiPoliciesBody.  # noqa: E501

        Most recent policy update timestamp.  # noqa: E501

        :return: The last_updated_at of this ApiPoliciesBody.  # noqa: E501
        :rtype: datetime
        """
        return self._last_updated_at

    @last_updated_at.setter
    def last_updated_at(self, last_updated_at):
        """Sets the last_updated_at of this ApiPoliciesBody.

        Most recent policy update timestamp.  # noqa: E501

        :param last_updated_at: The last_updated_at of this ApiPoliciesBody.  # noqa: E501
        :type: datetime
        """

        self._last_updated_at = last_updated_at

    @property
    def last_updated_by(self):
        """Gets the last_updated_by of this ApiPoliciesBody.  # noqa: E501

        Most recent policy editor.  # noqa: E501

        :return: The last_updated_by of this ApiPoliciesBody.  # noqa: E501
        :rtype: str
        """
        return self._last_updated_by

    @last_updated_by.setter
    def last_updated_by(self, last_updated_by):
        """Sets the last_updated_by of this ApiPoliciesBody.

        Most recent policy editor.  # noqa: E501

        :param last_updated_by: The last_updated_by of this ApiPoliciesBody.  # noqa: E501
        :type: str
        """

        self._last_updated_by = last_updated_by

    @property
    def statistics(self):
        """Gets the statistics of this ApiPoliciesBody.  # noqa: E501


        :return: The statistics of this ApiPoliciesBody.  # noqa: E501
        :rtype: PolicyapipoliciesStatistics
        """
        return self._statistics

    @statistics.setter
    def statistics(self, statistics):
        """Sets the statistics of this ApiPoliciesBody.


        :param statistics: The statistics of this ApiPoliciesBody.  # noqa: E501
        :type: PolicyapipoliciesStatistics
        """

        self._statistics = statistics

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ApiPoliciesBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApiPoliciesBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
